! Copyright (c) 1988 Edinburgh Portable Compilers Ltd. All Rights Reserved.
!
!     ENAMES
!     ------
! 
!     Author : Geoff Millard      Created on : 09 Feb 88
!
!     Modifications :
!
!     Date     Dev Vers   Description of Modification
!     ----     --- ----   ---------------------------
!     02/04/91  RT   35   Removed ECCOps LOGVAL, LOGSTK and LOGNEG
!     28/01/91  RT   34   Added C operatore CJTRUE,CDUPADD and CDUPSUB
!     28/01/91  RT   34   Add Pascal-E operators STRTOCH,STRPLUS,STRMOVE and
!                         PUSHSTR
!     28/01/91  RT   34   Common version (merge of C group 88K and SPARC)
!     09/03/90  GM   33.3 Add operator DCXUCHECK
!     22/02/90  TR   33.2 Renumber the bit Pasops since pascal-I/E conflict
!     28/01/90  AK   33.1 Merge Pascals changes (from 32.5)
!     16/01/90  GM   33   add TNCRR, RNDRR
!     07/01/90  GM   33   Common version
!     25/01/90  TR   32.5 Add BITADDR for Pascal
!     23/01/90  TR   32.5 Add SAVEBITREF and RESTBITREF for Pascal
!     22/01/90  TR   32.5 Add UPBITII, UPBITUU, UPBITIU, UPBITUI for Pascal
!                         and rename INDEXP as INDEXBITS
!     01/12/89  TR   32   Reinstate BNOT as generic EOP
!     28/11/89  TR   32   Add PasOps RCHKRNG and RCHKXX
!     30/10/89  TR   32   Add PasOp CHKUOVF to complement CHKIOVF
!     27/10/89 AJH   32   Add PasOps BNOT, BAND, BOR
!     30/08/89 AJH   32   Reduced set of ecodes for Pascal
!     09/08/89  TR   32   Rename PIMOD to INMOD and add UNMOD & IMDIV
!     24/05/89  TR   32   Add SETSD, SETINCL, SETEXCL & remove SETEMPTY
!     28/02/89  GB   32   Add operator PSEUDONOP
!     09/12/88  GB   31   Add operator GATHER
!     04/12/88  GB   30   Add operators FORCE, ENDFORCE
!     07/06/88  GB   29   Add operator VVSUB 
!     09/02/88  GM   28   Basis version for tracking changes
!*
%conststring(9)%array Eopname(0:255) = %c
{00} "HALT","IADD","ISUB","IMULT",  "IDIV" ,"INEG" ,"IABS" ,"IREM" ,
{08} "IAND","IOR" ,"INOT","IXOR" ,  "ISHLL","ISHRL","ISHLA","ISHRA",
{10} "IGT" ,"ILT" ,"IEQ" ,"INE"  ,  "IGE"  ,"ILE"  ,"BNOT" ,""     ,
{18} "JIGT","JILT","JIEQ","JINE" ,  "JIGE" ,"JILE" ,"JINTGZ","JINTLZ",
{20} "JINTZ","JINTNZ","JINTGEZ","JINTLEZ",  "ITWB" ,"","JUMP","",
{28} ""       ,"SFA"  ,"RETURN" ,"ASF" , "IPUSH" ,"IPOP"  ,"EXCH"  ,"DUPL",
{30} "DISCARD",""     ,""     ,"INDEX1", "INDEX2","INDEX4","INDEX8","INDEX",
{38} "MVB"    ,"CHK"  ,"TMASK" ,"MVW"  , "EZERO" ,""      ,"CPBGT" ,"CPBLT",
{40} "CPBEQ"  ,"CPBNE","CPBGE","CPBLE" , "EMAKED","ESPLITD","","", 
{48} "","","","", "","UMULT","UREM","UDIV",
{50} "UADD","USUB","UGT","ULT", "UEQ","UNE","UGE","ULE",
{58} "JUGT","JULT","JUEQ","JUNE", "JUGE","JULE","JUGTZ","JULTZ",
{60} "JUEQZ","JUNEZ","JUGEZ","JULEZ", "UCVTII","IADDST","ISUBST","IMULTST",
{68} "IDIVST","INEGST","UREMST","UDIVST","IANDST","IORST","INOTST","IXORST",
{70} "IREMST","RADD" ,"RSUB" ,"RMULT","RDIV" ,"RNEG" ,"RABS",""   ,
{78} "","","","", "","","","",
{80} "","","TNCRU","CVTSBI", "CVTUI","CVTUR","CVTIU","CVTRU",
{88} "CVTII","CVTIR","CVTRR","TNCRI", "RNDRI","EFLOOR","TNCRR","RNDRR",
{90} "RGT"  ,"RLT"  ,"REQ" ,"RNE"  ,"RGE"   ,"RLE" ,"JRGT","JRLT",
{98} "JREQ" ,"JRNE" ,"JRGE","JRLE" ,"JRGZ"  ,"JRLZ","JRZ" ,"JRNZ",
{A0} "JRGEZ","JRLEZ","RTWB","JTRUE","JFALSE",""    ,""    ,""    ,
{A8} ""     ,""     ,""    ,""     , ""     ,""    ,""    ,""    ,
{B0} ""     ,"UCHECK","FLTR","FLTD","FLTQ"  ,""    ,""    ,""    ,
{B8} "ESTORE","EDUPSTORE","PUSHVAL","PUSHADDR",
{BC} "EVAL" ,"EVALADDR","EADDRESS","EINTRES",
{C0} "EREALRES","ESIZE","EPOWER"  ,"EPOWERI",
{C4} "ARGPROC","PUSHBYTES","EAUXSF","EAUXADD",
{C8} "EAUXRES","EOLDLNB","ECFILL","ECDUP", "","EMCHIP","","",
{D0} "","","","", "","","","",
{D8} "","","","", "","","","",
{E0} "","","","", "","","","",
{E8} "","","","", "","","","",
{F0} "","","","", "WHEREMASK","WHERELSE","VELOG","WHEREST",
{F8} "WHEREND","VSEQR","VSEQI","VMASK", "VIMAGPT","VREALPT","VSTART","VEND"
!*
%conststring(11)%array Ef77opname(256:350)= %
{100} ""           ,"CXADD"       ,"CXSUB"      ,"CXMULT"     ,
{104} "CXDIV"      ,"CXNEG"       ,"CXASGN"     ,"CXEQ"       ,
{108} "CXNE"       ,""            ,"EANINT"     ,"EM1EXP"     ,
{10C} "ESIGN"      ,"ESIGN"       ,"EIMOD"      ,"ERMOD"      ,
{110} "EIDIM"      ,"ERDIM"       ,"EIMIN"      ,"ERMIN"      ,
{114} "EIMAX"      ,"ERMAX"       ,"EDMULT"     ,"ECONJG"     ,
{118} "ECHAR"      ,"EICHAR"      ,"EINDEXCHAR" ,"ECONCAT"    ,
{11C} "EASGNCHAR"  ,"ECOMPCHAR"   ,"ECMPLX1"    ,"ECMPLX2"    ,
{120} "EISHFT"     ,"EIBITS"      ,"EIBSET"     ,"EIBTEST"    ,
{124} "EIBCLR"     ,"EISHFTC"     ,"PROCARG"    ,"IPROCARG"   ,
{128} "CHARARG"    ,"IPROCCALL"   ,"ARGPROCCALL","CALLTPLATE" ,
{12C} "NOTEIORES"  ,"STKIORES"    ,"EFCVT"      ,"EFCVTASGN"  ,
{130} "EARGLEN"    ,"EFDVACC"     ,"EFNOTEVR"   ,"EFSETVR"    ,
{134} "EINCR"      ,"EDECR"       ,"ELOADB"     ,"ESTOREB"    ,
{138} "EINCRB"     ,"EDECRB"      ,"EDINIT"     ,"ELSHIFT"    ,
{13C} "ERSHIFT"    ,"EADJL"       ,"EADJR"      ,"EVERIFY"    ,
{140} "ECXRES"     ,"ERBIT"       ,"EWBIT"      ,"EMSTORE"    ,
{144} "ALLTEMP"    ,"ALLRES"      ,"MANTEMPS"   ,"ALLARR"     ,
{148} "DEALLARR"   ,"EMSTOREA"    ,"CXCVT"      ,"VVSUB"      ,
{14C} "VCSEDEF"    ,"FORCE"       ,"ENDFORCE"   ,"GATHER"     ,
{150} "PSEUDONOP"  ,"DCXADD"      ,"DCXSUB"     ,"DCXMULT"    ,
{154} "DCXDIV"     ,"DCXNEG"      ,"DCXASGN"    ,"DCXCVT"     ,
{158} "DCXEQ"      ,"DCXNEQ"      ,"DECMPLX1"   ,"DECMPLX2"   ,
{15C} ""           ,"DECONJG"     ,"DCXUCHECK"
!*
%conststring(11)%array Epasopname(511:643)= %c
{1FF} ""           ,""            ,""           ,""           ,
{203} ""           ,""            ,""           ,""           ,
{207} ""           ,""            ,""           ,""           ,
{20B} ""           ,""            ,"INMOD"      ,"UNMOD"      ,
{20F} "IMDIV"      ,""            ,""           ,"SETI"       ,
{213} "SETU"       ,"SETD"        ,"SETLE"      ,"SETEQ"      ,
{217} "SETNE"      ,"SETIN"       ,"SETSING"    ,"SETRANGE"   ,
{21B} "SETINCL"    ,"SETEXCL"     ,"SETSD"      ,""           ,
{21F} ""           ,"STRTOCH"     ,"STRPLUS"    ,"STRMOVE"    ,
{223} "PUSHSTR"    ,""            ,""           ,""           ,
{227} ""           ,"BAND"        ,"BOR"        ,""           ,
{22B} ""           ,""            ,""           ,""           ,
{22F} ""           ,"UPBITII"     ,"UPBITUU"    ,"UPBITIU"    ,
{233} "UPBITUI"    ,"INDEXBITS"   ,"SAVEBITREF" ,"RESTBITREF" ,
{237} "BITADDR"    ,""            ,""           ,""           ,
{23B} ""           ,""            ,""           ,""           ,
{23F} ""           ,""            ,""           ,""           ,
{243} ""           ,""            ,""           ,""           ,
{247} ""           ,""            ,""           ,""           ,
{24B} ""           ,""            ,""           ,""           ,
{24F} ""           ,""            ,""           ,""           ,
{253} ""           ,""            ,""           ,""           ,
{257} ""           ,""            ,"ISQR"       ,""           ,
{25B} ""           ,""            ,""           ,""           ,
{25F} ""           ,""            ,""           ,""           ,
{263} "RSQR"       ,""            ,""           ,""           ,
{267} ""           ,"SAVESTK"     ,"RECOVERSTK" ,""           ,
{26B} ""           ,""            ,""           ,"CHKRNG"     ,
{26F} "CHKXX"      ,"CHKSETRNG"   ,""           ,"RCHKRNG"    ,
{273} "RCHKXX"     ,"UCHKRNG"     ,"UCHKXX"     ,""           ,
{277} ""           ,""            ,""           ,"CHKUOVF"    ,
{27B} "CHKIOVF"    ,"CHKROVF"     ,""           ,""           ,
{27F} "TRAPOVF"    ,""            ,""           ,""           ,
{283} ""
!
%conststring(11)%array Ecopname(768:795)= %c
{300} "CMPSTR"     ,"CDUPADD"     ,"CDUPSUB"    ,"ECSTORE",
{304} "EPROCCALL"  ,"EPUSHSTR"    ,"ELDBITS"    ,"ESTBITS",
{308} "UADDST"     ,"USUBST"      ,"UMULTST"    ,"UDIVST",
{30C} "RADDST"     ,"RSUBST"      ,"RMULTST"    ,"RDIVST",
{310} "ISHLST"     ,"ISHRST"      ,"CEVAL"      ,"ECSAVE",
{314} "ECRESTORE"  ,"ISHRAST"     ,"CJFALSE"    ,"CJTRUE",
{318} "ESTRLEN"    ,"LOGSTK"      ,"LOGNEG"     ,"LOGVAL"

